<script setup lang="ts">
import { useCustomerStore } from '../stores/customer'

const customerStore = useCustomerStore()
</script>

<template>
  <v-dialog v-model="customerStore.dialog" persistent width="1024">
    <v-card rounded="xl">
      <v-card-title>
        <span class="text-h5">Customer Profile</span>
      </v-card-title>
      <v-card-text>
        <v-form ref="refForm" v-model="customerStore.form" @submit.prevent="customerStore.onSubmit">
          <v-container>
            <v-row>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="customerStore.editedCustomer.firstName"
                  :readonly="customerStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  class="mb-2"
                  clearable
                  label="First Name"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="customerStore.editedCustomer.lastName"
                  :readonly="customerStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Last Name"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="customerStore.editedCustomer.tel"
                  :readonly="customerStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Tel."
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="customerStore.editedCustomer.point"
                  :readonly="customerStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Point"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="customerStore.editedCustomer.birthDate"
                  :readonly="customerStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Birth Date"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model="customerStore.editedCustomer.registerDate"
                  :readonly="customerStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Register Date"
                ></v-text-field>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
        <small>*indicates required field</small>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue-darken-1" variant="text" @click="customerStore.closeDialog()">
          Close
        </v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="customerStore.save()"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <!-- Delete Dialog-->
  <v-dialog v-model="customerStore.dialogDelete" max-width="500px">
    <v-card>
      <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue-darken-1" variant="text" @click="customerStore.closeDelete"
          >Cancel</v-btn
        >
        <v-btn color="blue-darken-1" variant="text" @click="customerStore.deleteItemConfirm()"
          >OK</v-btn
        >
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
